#!/bin/sh
# 
# Make a hotspot access point with kali linux
#
# https://charlesreid1.com/wiki/Kali/Hotspot/Short
# 
# hotspot_config.sh <hotspot-network-interface>

USER_PROMPT=false
WRITE_CONFIG_FILES=false
WIFI_SSID="MyLittlePony"
WIFI_PW="AardvarkBadgerHedgehog"
AP_IP="192.168.4.1"
CLIENT_IP_START="192.168.4.2"
CLIENT_IP_END="192.168.4.20"
SUBNET_MASK="255.255.255.0"

if [ "$#" == "1" ]; then
	AP_INTERFACE="$1"
else
    echo ""
    echo ""
    echo "This script requires two input arguments:"
    echo "the network interface for the access point,"
	echo "and a network interface connected to internet:"
    echo ""
    echo "    hotspot_config.sh <hotspot-network-interface>"
    echo ""
    exit 1;
fi

# Ask the user if everything looks good

if [[ "$USER_PROMPT" == true ]]; then
    
    while true; do
        echo "$1 is the network interface that will host the access point"
        echo "$2 is the network interface that is connected to the internet"
        read -p "Is this information correct? (y/n) " yn
        case $yn in
            [Yy]* ) break;;
            [Nn]* ) echo "Aborting" && exit;;
            * ) echo "Please answer yes or no.";;
        esac
    done
    
    echo "k tnx"
fi

# Set dhcp and dns config files

if [[ $WRITE_CONFIG_FILES == true ]]; then

    cp /etc/dhcpcd.conf /etc/dhcpcd.conf.orig
    cat <<EOF > /etc/dhcpcd.conf
interface $AP_INTERFACE 
    static ip_address=$AP_IP/24
    nohook wpa_supplicant
EOF

    cp /etc/dnsmasq.conf /etc/dnsmasq.conf.orig
    cat <<EOF > /etc/dnsmasq.conf
interface=$AP_INTERFACE
dhcp-range=$CLIENT_IP_START,$CLIENT_IP_END,$SUBNET_MASK,24h
EOF

    cp /etc/hostapd/hostapd.conf /etc/hostapd/hostapd.conf.orig
    cat <<EOF > /etc/hostapd/hostapd.conf
interface=$AP_INTERFACE
driver=nl80211
ssid=$WIFI_SSID
hw_mode=g
channel=7
wmm_enabled=0
macaddr_acl=0
auth_algs=1
ignore_broadcast_ssid=0
wpa=2
wpa_passphrase=$WIFI_PW
wpa_key_mgmt=WPA-PSK
wpa_pairwise=TKIP
rsn_pairwise=CCMP
EOF

	cp /etc/default/hostapd /etc/default/hostapd.orig
    cat <<EOF > /etc/default/hostapd
DAEMON_CONF="/etc/hostapd/hostapd.conf"
EOF

else
    echo "Skipping creation of config files"
fi

echo "Your machine is configured
